//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
var script = {
  name: 'Erp_vue_gantt',

  // vue component name
  data() {
    return {
      downX: 0,
      down: false,
      leftSideWidthMin: 50,
      leftSideWidth: 200,
      leftSideWidthGhost: 200,
      list: [{
        _id: 1,
        name: 'bataa',
        startDate: 10,
        endDate: 25
      }]
    };
  },

  computed: {
    days() {
      const list = [];

      for (let i = 1; i < 100; i++) {
        list.push(i);
      }

      return list;
    }

  },

  created() {
    document.addEventListener('mouseup', this.handleMouseup);
  },

  methods: {
    handleMousemove(e) {
      this.leftSideWidthGhost = Math.max(this.leftSideWidthMin, this.leftSideWidth + e.x - this.downX);
      console.log('this.downX - e.X', this.downX - e.x);
      console.log('handleMousemove', e);
    },

    handleMouseup(e) {
      console.log('handleMouseup', e);

      if (this.down) {
        this.leftSideWidth = this.leftSideWidthGhost;
        this.down = false;
        document.removeEventListener('mousemove', this.handleMousemove);
      }
    },

    handleResizer(e) {
      console.log('handleResizer', e.x);

      if (!this.down) {
        this.downX = e.x;
        this.down = true;
        document.addEventListener('mousemove', this.handleMousemove);
      }
    }

  }
};

function normalizeComponent(template, style, script, scopeId, isFunctionalTemplate, moduleIdentifier /* server only */, shadowMode, createInjector, createInjectorSSR, createInjectorShadow) {
    if (typeof shadowMode !== 'boolean') {
        createInjectorSSR = createInjector;
        createInjector = shadowMode;
        shadowMode = false;
    }
    // Vue.extend constructor export interop.
    const options = typeof script === 'function' ? script.options : script;
    // render functions
    if (template && template.render) {
        options.render = template.render;
        options.staticRenderFns = template.staticRenderFns;
        options._compiled = true;
        // functional template
        if (isFunctionalTemplate) {
            options.functional = true;
        }
    }
    // scopedId
    if (scopeId) {
        options._scopeId = scopeId;
    }
    let hook;
    if (moduleIdentifier) {
        // server build
        hook = function (context) {
            // 2.3 injection
            context =
                context || // cached call
                    (this.$vnode && this.$vnode.ssrContext) || // stateful
                    (this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext); // functional
            // 2.2 with runInNewContext: true
            if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
                context = __VUE_SSR_CONTEXT__;
            }
            // inject component styles
            if (style) {
                style.call(this, createInjectorSSR(context));
            }
            // register component module identifier for async chunk inference
            if (context && context._registeredComponents) {
                context._registeredComponents.add(moduleIdentifier);
            }
        };
        // used by ssr in case component is cached and beforeCreate
        // never gets called
        options._ssrRegister = hook;
    }
    else if (style) {
        hook = shadowMode
            ? function (context) {
                style.call(this, createInjectorShadow(context, this.$root.$options.shadowRoot));
            }
            : function (context) {
                style.call(this, createInjector(context));
            };
    }
    if (hook) {
        if (options.functional) {
            // register for functional component in vue file
            const originalRender = options.render;
            options.render = function renderWithStyleInjection(h, context) {
                hook.call(context);
                return originalRender(h, context);
            };
        }
        else {
            // inject component registration as beforeCreate hook
            const existing = options.beforeCreate;
            options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
        }
    }
    return script;
}

const isOldIE = typeof navigator !== 'undefined' &&
    /msie [6-9]\\b/.test(navigator.userAgent.toLowerCase());
function createInjector(context) {
    return (id, style) => addStyle(id, style);
}
let HEAD;
const styles = {};
function addStyle(id, css) {
    const group = isOldIE ? css.media || 'default' : id;
    const style = styles[group] || (styles[group] = { ids: new Set(), styles: [] });
    if (!style.ids.has(id)) {
        style.ids.add(id);
        let code = css.source;
        if (css.map) {
            // https://developer.chrome.com/devtools/docs/javascript-debugging
            // this makes source maps inside style tags work properly in Chrome
            code += '\n/*# sourceURL=' + css.map.sources[0] + ' */';
            // http://stackoverflow.com/a/26603875
            code +=
                '\n/*# sourceMappingURL=data:application/json;base64,' +
                    btoa(unescape(encodeURIComponent(JSON.stringify(css.map)))) +
                    ' */';
        }
        if (!style.element) {
            style.element = document.createElement('style');
            style.element.type = 'text/css';
            if (css.media)
                style.element.setAttribute('media', css.media);
            if (HEAD === undefined) {
                HEAD = document.head || document.getElementsByTagName('head')[0];
            }
            HEAD.appendChild(style.element);
        }
        if ('styleSheet' in style.element) {
            style.styles.push(code);
            style.element.styleSheet.cssText = style.styles
                .filter(Boolean)
                .join('\n');
        }
        else {
            const index = style.ids.size - 1;
            const textNode = document.createTextNode(code);
            const nodes = style.element.childNodes;
            if (nodes[index])
                style.element.removeChild(nodes[index]);
            if (nodes.length)
                style.element.insertBefore(textNode, nodes[index]);
            else
                style.element.appendChild(textNode);
        }
    }
}

/* script */
const __vue_script__ = script;
/* template */

var __vue_render__ = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    staticClass: "erp_vue_gantt"
  }, [_c('div', {
    staticClass: "left-side",
    style: "width: " + _vm.leftSideWidth + "px"
  }, [_c('div', {
    staticStyle: {
      "height": "24px"
    }
  }, [_vm._v("\n      Нэр\n    ")]), _vm._v(" "), _vm._l(_vm.list, function (item) {
    return _c('div', {
      key: item._id,
      staticStyle: {
        "height": "24px"
      }
    }, [_vm._v("\n      " + _vm._s(item.name) + "\n    ")]);
  })], 2), _vm._v(" "), _c('div', {
    staticClass: "resizer",
    on: {
      "mousedown": function ($event) {
        if (!$event.type.indexOf('key') && _vm._k($event.keyCode, "left", 37, $event.key, ["Left", "ArrowLeft"])) {
          return null;
        }

        if ('button' in $event && $event.button !== 0) {
          return null;
        }

        return _vm.handleResizer.apply(null, arguments);
      },
      "mouseup": _vm.handleResizer
    }
  }, [_c('div', {
    staticClass: "resizer-border"
  })]), _vm._v(" "), _c('div', {
    staticClass: "content"
  }, [_c('div', {
    staticClass: "row"
  }, _vm._l(_vm.days, function (day) {
    return _c('div', {
      key: day.toString(),
      staticClass: "column"
    }, [_c('span', {
      staticStyle: {
        "white-space": "nowrap"
      }
    }, [_vm._v(_vm._s(day))])]);
  }), 0), _vm._v(" "), _vm._l(_vm.list, function (item) {
    return _c('div', {
      key: item._id,
      staticClass: "row"
    }, [_vm._l(_vm.days, function (day) {
      return _c('div', {
        key: day.toString(),
        staticClass: "column"
      });
    }), _vm._v(" "), _c('div', {
      staticClass: "progress",
      style: "top: 3px; left: " + ((item.startDate - 1) * 51 + 2) + "px; width: " + ((item.endDate + 1 - item.startDate) * 51 - 4) + "px"
    })], 2);
  })], 2), _vm._v(" "), _vm.down ? _c('div', {
    staticClass: "resizer-box"
  }, [_c('div', {
    staticClass: "resizer",
    style: "width: " + (_vm.leftSideWidthGhost + 3) + "px"
  })]) : _vm._e()]);
};

var __vue_staticRenderFns__ = [];
/* style */

const __vue_inject_styles__ = function (inject) {
  if (!inject) return;
  inject("data-v-7b2e0914_0", {
    source: ".erp_vue_gantt[data-v-7b2e0914]{min-height:500px;display:flex;flex-direction:row;position:relative;height:100%}.erp_vue_gantt>.resizer-box[data-v-7b2e0914]{background:#00000033;top:0;left:0;position:absolute;width:100%;height:100%}.erp_vue_gantt>.resizer-box>.resizer[data-v-7b2e0914]{height:100%;border-right:1px solid #00f}.erp_vue_gantt>.resizer[data-v-7b2e0914]{border-left:3px solid #fff;border-right:3px solid gray;cursor:ew-resize}.erp_vue_gantt>.resizer>.resizer-border[data-v-7b2e0914]{height:100%;width:1px;border-right:1px solid red}.erp_vue_gantt>.content[data-v-7b2e0914]{flex:1;background:#aaa;overflow:auto;position:relative}.erp_vue_gantt>.content>.row[data-v-7b2e0914]{position:relative;width:fit-content;display:flex;flex-direction:row;justify-content:flex-start;align-items:flex-start}.erp_vue_gantt>.content>.row>.progress[data-v-7b2e0914]{position:absolute;width:200px;height:20px;background:red;border-radius:4px}.erp_vue_gantt>.content>.row>.column[data-v-7b2e0914]{width:50px;min-width:50px;border-left:thin solid #000;border-top:thin solid #000;height:24px}.erp_vue_gantt>.content>.row[data-v-7b2e0914]:last-child{border-bottom:thin solid #000}.erp_vue_gantt>.content>.row>.column[data-v-7b2e0914]:last-child{border-right:thin solid #000}",
    map: undefined,
    media: undefined
  });
};
/* scoped */


const __vue_scope_id__ = "data-v-7b2e0914";
/* module identifier */

const __vue_module_identifier__ = undefined;
/* functional template */

const __vue_is_functional_template__ = false;
/* style inject SSR */

/* style inject shadow dom */

const __vue_component__ = /*#__PURE__*/normalizeComponent({
  render: __vue_render__,
  staticRenderFns: __vue_staticRenderFns__
}, __vue_inject_styles__, __vue_script__, __vue_scope_id__, __vue_is_functional_template__, __vue_module_identifier__, false, createInjector, undefined, undefined);

// Import vue component
// IIFE injects install function into component, allowing component
// to be registered via Vue.use() as well as Vue.component(),

var entry_esm = /*#__PURE__*/(() => {
  // Get component instance
  const installable = __vue_component__; // Attach install function executed by Vue.use()

  installable.install = Vue => {
    Vue.component('Erp_vue_gantt', installable);
  };

  return installable;
})(); // It's possible to expose named exports when writing components that can
// also be used as directives, etc. - eg. import { RollupDemoDirective } from 'rollup-demo';
// export const RollupDemoDirective = directive;

export default entry_esm;
