'use strict';function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];

  if (_i == null) return;
  var _arr = [];
  var _n = true;
  var _d = false;

  var _s, _e;

  try {
    for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
var script = {
  name: 'Erp_vue_gantt',
  // vue component name
  data: function data() {
    return {
      downX: 0,
      down: false,
      leftSideWidthMin: 50,
      leftSideWidth: 200,
      leftSideWidthGhost: 200,
      list: [{
        _id: 1,
        name: 'bataa',
        startDate: 10,
        endDate: 25
      }]
    };
  },
  computed: {
    days: function days() {
      var list = [];

      for (var i = 1; i < 100; i++) {
        list.push(i);
      }

      return list;
    }
  },
  created: function created() {
    document.addEventListener('mouseup', this.handleMouseup);
  },
  methods: {
    handleMousemove: function handleMousemove(e) {
      this.leftSideWidthGhost = Math.max(this.leftSideWidthMin, this.leftSideWidth + e.x - this.downX);
      console.log('this.downX - e.X', this.downX - e.x);
      console.log('handleMousemove', e);
    },
    handleMouseup: function handleMouseup(e) {
      console.log('handleMouseup', e);

      if (this.down) {
        this.leftSideWidth = this.leftSideWidthGhost;
        this.down = false;
        document.removeEventListener('mousemove', this.handleMousemove);
      }
    },
    handleResizer: function handleResizer(e) {
      console.log('handleResizer', e.x);

      if (!this.down) {
        this.downX = e.x;
        this.down = true;
        document.addEventListener('mousemove', this.handleMousemove);
      }
    }
  }
};function normalizeComponent(template, style, script, scopeId, isFunctionalTemplate, moduleIdentifier /* server only */, shadowMode, createInjector, createInjectorSSR, createInjectorShadow) {
    if (typeof shadowMode !== 'boolean') {
        createInjectorSSR = createInjector;
        createInjector = shadowMode;
        shadowMode = false;
    }
    // Vue.extend constructor export interop.
    const options = typeof script === 'function' ? script.options : script;
    // render functions
    if (template && template.render) {
        options.render = template.render;
        options.staticRenderFns = template.staticRenderFns;
        options._compiled = true;
        // functional template
        if (isFunctionalTemplate) {
            options.functional = true;
        }
    }
    // scopedId
    if (scopeId) {
        options._scopeId = scopeId;
    }
    let hook;
    if (moduleIdentifier) {
        // server build
        hook = function (context) {
            // 2.3 injection
            context =
                context || // cached call
                    (this.$vnode && this.$vnode.ssrContext) || // stateful
                    (this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext); // functional
            // 2.2 with runInNewContext: true
            if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
                context = __VUE_SSR_CONTEXT__;
            }
            // inject component styles
            if (style) {
                style.call(this, createInjectorSSR(context));
            }
            // register component module identifier for async chunk inference
            if (context && context._registeredComponents) {
                context._registeredComponents.add(moduleIdentifier);
            }
        };
        // used by ssr in case component is cached and beforeCreate
        // never gets called
        options._ssrRegister = hook;
    }
    else if (style) {
        hook = shadowMode
            ? function (context) {
                style.call(this, createInjectorShadow(context, this.$root.$options.shadowRoot));
            }
            : function (context) {
                style.call(this, createInjector(context));
            };
    }
    if (hook) {
        if (options.functional) {
            // register for functional component in vue file
            const originalRender = options.render;
            options.render = function renderWithStyleInjection(h, context) {
                hook.call(context);
                return originalRender(h, context);
            };
        }
        else {
            // inject component registration as beforeCreate hook
            const existing = options.beforeCreate;
            options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
        }
    }
    return script;
}function createInjectorSSR(context) {
    if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
        context = __VUE_SSR_CONTEXT__;
    }
    if (!context)
        return () => { };
    if (!('styles' in context)) {
        context._styles = context._styles || {};
        Object.defineProperty(context, 'styles', {
            enumerable: true,
            get: () => context._renderStyles(context._styles)
        });
        context._renderStyles = context._renderStyles || renderStyles;
    }
    return (id, style) => addStyle(id, style, context);
}
function addStyle(id, css, context) {
    const group = css.media || 'default' ;
    const style = context._styles[group] || (context._styles[group] = { ids: [], css: '' });
    if (!style.ids.includes(id)) {
        style.media = css.media;
        style.ids.push(id);
        let code = css.source;
        style.css += code + '\n';
    }
}
function renderStyles(styles) {
    let css = '';
    for (const key in styles) {
        const style = styles[key];
        css +=
            '<style data-vue-ssr-id="' +
                Array.from(style.ids).join(' ') +
                '"' +
                (style.media ? ' media="' + style.media + '"' : '') +
                '>' +
                style.css +
                '</style>';
    }
    return css;
}/* script */
var __vue_script__ = script;
/* template */

var __vue_render__ = function __vue_render__() {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    staticClass: "erp_vue_gantt"
  }, [_vm._ssrNode("<div class=\"left-side\"" + _vm._ssrStyle(null, "width: " + _vm.leftSideWidth + "px", null) + " data-v-7b2e0914><div style=\"height: 24px;\" data-v-7b2e0914>\n      Нэр\n    </div> " + _vm._ssrList(_vm.list, function (item) {
    return "<div style=\"height: 24px;\" data-v-7b2e0914>" + _vm._ssrEscape("\n      " + _vm._s(item.name) + "\n    ") + "</div>";
  }) + "</div> <div class=\"resizer\" data-v-7b2e0914><div class=\"resizer-border\" data-v-7b2e0914></div></div> <div class=\"content\" data-v-7b2e0914><div class=\"row\" data-v-7b2e0914>" + _vm._ssrList(_vm.days, function (day) {
    return "<div class=\"column\" data-v-7b2e0914><span style=\"white-space: nowrap;\" data-v-7b2e0914>" + _vm._ssrEscape(_vm._s(day)) + "</span></div>";
  }) + "</div> " + _vm._ssrList(_vm.list, function (item) {
    return "<div class=\"row\" data-v-7b2e0914>" + _vm._ssrList(_vm.days, function (day) {
      return "<div class=\"column\" data-v-7b2e0914></div>";
    }) + " <div class=\"progress\"" + _vm._ssrStyle(null, "top: 3px; left: " + ((item.startDate - 1) * 51 + 2) + "px; width: " + ((item.endDate + 1 - item.startDate) * 51 - 4) + "px", null) + " data-v-7b2e0914></div></div>";
  }) + "</div> " + (_vm.down ? "<div class=\"resizer-box\" data-v-7b2e0914><div class=\"resizer\"" + _vm._ssrStyle(null, "width: " + (_vm.leftSideWidthGhost + 3) + "px", null) + " data-v-7b2e0914></div></div>" : "<!---->"))]);
};

var __vue_staticRenderFns__ = [];
/* style */

var __vue_inject_styles__ = function __vue_inject_styles__(inject) {
  if (!inject) return;
  inject("data-v-7b2e0914_0", {
    source: ".erp_vue_gantt[data-v-7b2e0914]{min-height:500px;display:flex;flex-direction:row;position:relative;height:100%}.erp_vue_gantt>.resizer-box[data-v-7b2e0914]{background:#00000033;top:0;left:0;position:absolute;width:100%;height:100%}.erp_vue_gantt>.resizer-box>.resizer[data-v-7b2e0914]{height:100%;border-right:1px solid #00f}.erp_vue_gantt>.resizer[data-v-7b2e0914]{border-left:3px solid #fff;border-right:3px solid gray;cursor:ew-resize}.erp_vue_gantt>.resizer>.resizer-border[data-v-7b2e0914]{height:100%;width:1px;border-right:1px solid red}.erp_vue_gantt>.content[data-v-7b2e0914]{flex:1;background:#aaa;overflow:auto;position:relative}.erp_vue_gantt>.content>.row[data-v-7b2e0914]{position:relative;width:fit-content;display:flex;flex-direction:row;justify-content:flex-start;align-items:flex-start}.erp_vue_gantt>.content>.row>.progress[data-v-7b2e0914]{position:absolute;width:200px;height:20px;background:red;border-radius:4px}.erp_vue_gantt>.content>.row>.column[data-v-7b2e0914]{width:50px;min-width:50px;border-left:thin solid #000;border-top:thin solid #000;height:24px}.erp_vue_gantt>.content>.row[data-v-7b2e0914]:last-child{border-bottom:thin solid #000}.erp_vue_gantt>.content>.row>.column[data-v-7b2e0914]:last-child{border-right:thin solid #000}",
    map: undefined,
    media: undefined
  });
};
/* scoped */


var __vue_scope_id__ = "data-v-7b2e0914";
/* module identifier */

var __vue_module_identifier__ = "data-v-7b2e0914";
/* functional template */

var __vue_is_functional_template__ = false;
/* style inject shadow dom */

var __vue_component__ = /*#__PURE__*/normalizeComponent({
  render: __vue_render__,
  staticRenderFns: __vue_staticRenderFns__
}, __vue_inject_styles__, __vue_script__, __vue_scope_id__, __vue_is_functional_template__, __vue_module_identifier__, false, undefined, createInjectorSSR, undefined);// Import vue component
// IIFE injects install function into component, allowing component
// to be registered via Vue.use() as well as Vue.component(),

var component = /*#__PURE__*/(function () {
  // Get component instance
  var installable = __vue_component__; // Attach install function executed by Vue.use()

  installable.install = function (Vue) {
    Vue.component('Erp_vue_gantt', installable);
  };

  return installable;
})(); // It's possible to expose named exports when writing components that can
// also be used as directives, etc. - eg. import { RollupDemoDirective } from 'rollup-demo';
// export const RollupDemoDirective = directive;
var namedExports=/*#__PURE__*/Object.freeze({__proto__:null,'default': component});// only expose one global var, with named exports exposed as properties of
// that global var (eg. plugin.namedExport)

Object.entries(namedExports).forEach(function (_ref) {
  var _ref2 = _slicedToArray(_ref, 2),
      exportName = _ref2[0],
      exported = _ref2[1];

  if (exportName !== 'default') component[exportName] = exported;
});module.exports=component;